<?php

	// classe articles travaillant sur une base d'articles compose des tables suivantes
	// articles : (code, nom, prix, stockActuel, stockMinimum)
	// users : (login, mdp, admin)
	// droits : (login, table, ajouter, modifier, supprimer, consulter)

	// c'est l'utilisateur de la classe qui doit fournir le login/mdp qui permet de faire toute opration sur la base
	// il a donc dj tous les droits sur la base. Ceci implique qu'il n'y a pas  prendre
	// de prcautions de scurit particulires ici

	// bibliothques
  require_once 'DB.php';
	
  class articles{

  	// attributs
    var $sDSN;					// la chane de connexion
  	var $sDatabase;			// le nom de la base
    var $oDB;						// connexion  la base
    var $aErreurs;			// liste d'erreurs
    var $oRsultats;		// rsultat d'une requte
		var $connect;			// boolen qui indique si on est connect ou non  la base
		var $sQuery;				// la dernire requte excute
    var $sUser;					// identit de l'utilisateur de la connexion
    var $sMdp;					// son mot de passe
    var $bAdmin;				//  vrai si l'utilisateur est administrateur
    var $dDroits;				// le dictionnaire de ses droits table ->> array(consulter,ajouter,supprimer,modifier)

    // constructeur
    function articles($dDSN,$sUser,$sMdp){

    	// $dDSN : dictionnaire dfinissant la liaison  tablir
      // $dDSN['sgbd'] : le type du SGBD auquel il faut se connecter
      // $dDSN['host'] : le nom de la machine hte qui l'hberge      
      // $dDSN['database'] : le nom de la base  laquelle il faut se connecter      
      // $dDSN['admin'] : le login du propitaire de la base  laquelle il faut se connecter
      // $dDSN['mdpadmin'] : son mot de passe
      // $sUser : le login de l'utilisateur qui veut exploiter la base des articles
      // $sMdp : son mot de passe
      
      // cre dans $oDB une connexion  la base dfinie par $dDSN sous l'identit de $dDSN['admin']
      // si la connexion russit et que l'utilisateur $sUser est authentifi  
      	// charge les droits dans $bAdmin et $dDroits les droits de l'utilisateur $sUser
      	// met dans $sDSN la chane de connexion  la base
      	// met dans $sDataBase le nom de la base  laquelle on se connecte
        // met $connect  vrai
      // si la connexion choue ou si l'utilisateur $sUser n'est pas identifi correctement
      	// met les msg d'erreurs adquats dans la liste $aErreurs
        // ferme la connexion si besoin est
        // met $connect  faux 
                   
      // raz liste des erreurs
			$this->aErreurs=array();
      
      // on cre une connexion  la base $sDSN
      $this->sDSN=$dDSN["sgbd"]."://".$dDSN["admin"].":".$dDSN["mdpadmin"]."@".$dDSN["host"]."/".$dDSN["database"];
      $this->sDatabase=$dDSN["database"];
      $this->connect();

      // connect ?
      if( ! $this->connect) return;
     
      // la connexion a russi - on mmorise certains de ses attributs     
      $this->connect=TRUE;     

      // l'utilisateur existe-t-il, s'est-il correctement identifi et a-t-il des droits ?
      list($iErreur,$sAdmin,$dDroits)=$this->existeUser($sUser,$sMdp);
			// on examine le rsultat
      if($iErreur==-1){
      	// pb imprvu - on se dconnecte
        $this->disconnect();
        // retour
        return;
      }//if
			// on examine le rsultat
      if($iErreur==1){
      	// l'utilisateur n'existe pas
        $this->aErreurs[]="L'utilisateur [$sUser] n'a pas t reconnu";
        // on se dconnecte
        $this->disconnect();
        // retour
        return;
      }//if
			// on examine le rsultat
      if($iErreur==2){
      	// l'utilisateur n'existe pas
        $this->aErreurs[]="L'utilisateur [$sUser] n'a aucun droit sur aucune table";
        // on se dconnecte
        $this->disconnect();
        // retour
        return;
      }//if

      // on mmorise les attributs lis  l'utilisateur
      $this->sUser=$sUser;
      $this->sMdp=$sMdp;
      $this->bAdmin=($sAdmin=="y");
      $this->dDroits=$dDroits;      
    }//constructeur

    // ------------------------------------------------------------------
    function connect(){
    	// (re)connexion  la base
      // raz liste des erreurs
			$this->aErreurs=array();
      // on cre une connexion  la base $sDSN
    	$this->oDB=DB::connect($this->sDSN,true);
    	// erreur ?
    	if(DB::iserror($this->oDB)){
      	// on note l'erreur
      	$this->aErreurs[]="Echec de la connexion  la base [".$this->sDatabase."] : [".$this->oDB->getMessage()."]";
        // la connexion a chou
        $this->connect=FALSE;
        // fin
        return;
      }
      // on est connect
      $this->connect=TRUE;
    }//connect
    
    // ------------------------------------------------------------------
    function disconnect(){
      // si on est connect, on ferme la connexion  la base $sDSN
    	if($this->connect){
  			$this->oDB->disconnect();
      	// on est dconnect
        $this->connect=FALSE;
			}//if
    }//disconnect
    
    // -------------------------------------------------------------------
    function execute($sQuery,$bAdmin){
    	// $sQuery : requte  excuter
      // $bAdmin : vrai si demande d'excution en tant qu'administrateur
      
    	// on mmorise la requte
			$this->sQuery=$sQuery;    
			// requte administrateur ?
      if(! $bAdmin){
      	// un administrateur a le droit d'excuter tte requte
      	if (! $this->bAdmin){
      		$this->aErreurs=array("L'utilisateur [$this->sUser] n'a pas les droits d'administration");
      		return;
      	}//if
      	// raz erreurs
      	$this->aErreurs=array();
      }//if
      
      // est-on connect ?
      if(! $this->connect){
      	// on note l'erreur
        $this->aErreurs[]="Pas de connexion existante  la base [$this->sDatabase]";
        // fin
        return;
      }//if
      
      // excution de la requte
      $this->oRsultats=$this->oDB->query($sQuery);
      
    	// erreur ?
    	if(DB::iserror($this->oRsultats)){
    		// on note l'erreur
    		$this->aErreurs[]="Echec de la requte [$sQuery] : [".$this->oRsultats->getMessage()."]";
      	// retour
        return;
      }//if
      
    }//execute

    // --------------------------------------------------------------------------
    function addArticle($dArticle){
    	// ajoute un article $dArticle (code, nom, prix, stockActuel, stockMinimum)  la table des articles
      
      // raz erreurs
      $this->aErreurs=array();
      
      // a-t-on les droits ?
      if(! $this->bAdmin && $this->dDroits['articles']['ajouter']!="y"){
      	// pas les droits suffisants
        $this->aErreurs=array("L'utilisateur [".$this->sUser."] n'a pas les droits suffisants pour cette opration");
        // fin
        return;
      }//if        

			// l'article ne doit pas dj exister
      $dArticle['code']=trim($dArticle['code']);
      if($this->existeArticle($dArticle['code'])){
      	// erreur
        $this->aErreurs=array("L'article de code [".$dArticle['code']."] existe dj");
        // fin
        return;
      }//if
                  
      // on vrifie la validit des donnes
      $this->vrifierArticle($dArticle);
      // des erreurs ?
      if(count($this->aErreurs)!=0){
        // fin
        return;
      }//if

      // requte d'insertion
      $sQuery="insert into ARTICLES (code, nom, prix, stockActuel, stockMinimum) values ('".
      	addslashes($dArticle['code'])."','".addslashes($dArticle['nom'])."',".$dArticle['prix'].
        ",".$dArticle['stockActuel'].",".$dArticle['stockMinimum'].")";

      // excution
      $this->execute($sQuery,TRUE);      
    }//add          

    // ----------------------------------------------------------------------
    function modifyArticle($dArticle){
    	// modifie un article $dArticle (code, nom, prix, stockActuel, stockMinimum) de la table des articles
      
      // raz erreurs
      $this->aErreurs=array();
      // a-t-on les droits ?
      if(! $this->bAdmin && $this->dDroits['articles']['modifier']!="y"){
      	// pas les droits suffisants
        $this->aErreurs=array("L'utilisateur [".$this->sUser."] n'a pas les droits suffisants pour cette opration");
        // fin
        return;
      }//if        
      // on vrifie la validit des donnes
      $rsultats=$this->vrifierArticle($dArticle);
      // des erreurs ?
      if(count($this->aErreurs)!=0){
        // fin
        return;
      }//if
      
      // requte de mise  jour
      $sQuery="update ARTICLES set nom='".addslashes($dArticle['nom'])."',prix=".$dArticle['prix'].
        ",stockActuel=".$dArticle['stockActuel'].",stockMinimum=".$dArticle['stockMinimum'].
        " where code='".addslashes($dArticle['code'])."'";
        
      // excution
      $this->execute($sQuery,TRUE);
    }//update

    // ----------------------------------------------------------------------
    function deleteArticle($sCode){
    	// supprime un article de la table des articles
      // dont on a le code $sCode
     
      // raz erreurs
      $this->aErreurs=array();
      // a-t-on les droits ?
      if(! $this->bAdmin && $this->dDroits['articles']['modifier']!="y"){
      	// pas les droits suffisants
        $this->aErreurs=array("L'utilisateur [".$this->sUser."] n'a pas les droits suffisants pour cette opration");
        // fin
        return;
      }//if        
      
      // requte de suppression
	    $sQuery="delete from ARTICLES where code='".addslashes($sCode)."'";
        
      // excution
      $this->execute($sQuery,TRUE);
    }//delete
    
    // ----------------------------------------------------------------------
    function vrifierArticle(&$dArticle){
    	// vrifie la validit d'un article $dArticle (code, nom, prix, stockActuel, stockMinimum)
      
    	// l'article doit avoir 4 caractres
      if(strlen(trim($dArticle['code']))!=4) $this->aErreurs[]="Le code de l'article doit avoir 4 caractres exactement";
    	// le nom ne doit pas tre vide
      if(preg_match("/^\s*$/",$dArticle['nom'])) $this->aErreurs[]="Le nom de l'article ne peut tre vide";
      // prix
      if(! preg_match("/^\s*\d+(\.\d*)*\s*$/",$dArticle['prix'])){
       $this->aErreurs[]="Prix ".$dArticle['prix']." invalide";
      }//if
      // stock actuel
      if(! preg_match("/^\s*\d+\s*$/",$dArticle['stockActuel'])){ 
      	$this->aErreurs[]="Stock actuel ".$dArticle['stockActuel']." invalide";
      }//if
      // stock minimum
      if(! preg_match("/^\s*\d+\s*$/",$dArticle['stockMinimum'])){ 
      	$this->aErreurs[]="Stock minimum ".$dArticle['stockMinimum']." invalide";
      }//if
    }//vrifier

    // --------------------------------------------------------------------------
    function selectArticles($dQuery){
    	// excute une requte select la table des articles
      // celle-ci a trois composantes
      // liste des colonnes dans $dQuery['colonnes']
      // filtrage dans $dQuery['where']
      // ordre de prsentation dans $dQuery['orderby']
      
      // raz erreurs
      $this->aErreurs=array();
      
      // a-t-on les droits ?
      if(! $this->bAdmin && $this->dDroits['articles']['consulter']!="y"){
      	// pas les droits suffisants
        $this->aErreurs=array("L'utilisateur [".$this->sUser."] n'a pas les droits suffisants pour cette opration");
        // fin
        return;
      }//if        
      
      // cration de la requte
      $requte="select";
      if(trim($dQuery['colonnes'])!="") $requte.=" ".addslashes($dQuery['colonnes']);
      $requte.=" from articles";
      if(trim($dQuery['where'])!="") $requte.=" where ".$dQuery['where'];
      if(trim($dQuery['orderby'])!="") $requte.=" order by ".addslashes($dQuery['orderby']);    

      // excution de la requte
      $this->execute($requte,TRUE);
    }//selectArticles            
    
		// --------------------------------
    function existeArticle($sCode){
    	// rend TRUE si l'article de code $sCode existe dans la table des articles
      
    	// raz erreurs
      $aErreurs=array();
      // indique si l'article de code $sCode existe
      $this->execute("select code from articles where code='".$sCode."'",TRUE);
      // a-t-on trouv ?
      if(count($this->aErreurs)==0 && $this->oRsultats->numRows()==1)
      	return TRUE; else return FALSE;
    }//existeArticle
   
    // --------------------------------------
    function existeUser($sUser,$sMdp){
    	// vrification de l'existence de l'utilisateur $sUser ayant le mot de passe $sMdp
      // rend (int $iErreur, string $sAdmin, hashtable $dDroits)
      // $iErreur = -1 pour toute erreur d'exploitation de la base - la liste $aErreurs est alors renseigne
      // $iErreur = 1 si l'utilisateur n'est pas trouv (absent ou pas bon mot de passe)
      // $iErreur = 2 si l'utilisateur existe mais n'a aucun droit dans la table des droits
      // $iErreur = 3 si l'utilisateur existe et est administrateur
      // $iErreur = 0 si l'utilisateur existe et n'est pas administrateur
      // $sAdmin="y" ssi l'utilisateur existe et est administrateur ($iErreur==3), sinon il est gal  la chane vide
      // $dDroits est le dictionnaire des droits de l'utilisateur s'il n'est pas administrateur ($iErreur==0)
      // sinon c'est un tableau vide
      // les cls du dictionnaire sont les tables sur lesquelles l'utilisateur a des droits
      // la valeur associe  cette table est  son tour un dictionnaire o les cls sont les droits
      // (consulter, ajouter, modifier, supprimer) et les valeurs les chanes 'y' (yes) ou 'n' (no) selon les cas

      // protection des paramtres
     	$sUser=addslashes($sUser);
     	$sMdp=addslashes($sMdp);
      
      // on vrifie l'exsitence de l'utilisateur dans la table USERS
      $sSelect="select admin from users"
        ." where users.login='".$sUser."'"
       	." and users.mdp='".$sMdp."'";
      $this->execute($sSelect,TRUE);
      // des erreurs ?
      if(count($this->aErreurs)!=0) return array(-1,"",array());       
      // a-t-on trouv une ligne et une seule ?
      if($this->oRsultats->numRows()!=1) return array(1,"",array());
      // on examine le rsultat
      $dUser = $this->oRsultats->fetchRow(DB_FETCHMODE_ASSOC);
      // est-il administrateur ?
      $dUser['admin']=strtolower($dUser['admin']);
      if($dUser['admin']=="y") return array(3,"y",array());
      // on recherche les droits de l'utilisateur
      $sSelect="select droits.table, droits.consulter, droits.ajouter, droits.modifier, droits.supprimer from droits".
      	" where login='".$sUser."'";
      $this->execute($sSelect,TRUE);        
      // des erreurs ?
      if(count($this->aErreurs)!=0) return array(-1,"",array());       
      // a-t-on trouv au moins une ligne ?
      if($this->oRsultats->numRows()!=1){
      	// l'utilisateur n'est pas dans la table des droits
       	return array(2,strtolower($dUser["admin"]),array());
     	}//if
      // on rcupre les droits de l'utilisateur
      while($ligne = $this->oRsultats->fetchRow(DB_FETCHMODE_ASSOC)){
      	$dDroits[strtolower($ligne['table'])]=array(
        	'consulter'=>strtolower($ligne['consulter']),
          'ajouter'=>strtolower($ligne['ajouter']),
        	'modifier'=>strtolower($ligne['modifier']),
          'supprimer'=>strtolower($ligne['supprimer']));
      }//while
      // on retourne le rsultat
      return array(0,$dUser['admin'],$dDroits);  
    }//existeUser

    // --------------------------------------
    function getCodes(){
    	// rend le tableau des codes

      // raz erreurs
      $this->aErreurs=array();     
      // a-t-on les droits ?
      if(! $this->bAdmin && $this->dDroits['articles']['modifier']!="y"){
      	// pas les droits suffisants
        $this->aErreurs=array("L'utilisateur [".$this->sUser."] n'a pas les droits suffisants pour cette opration");
        // fin
        return array();
      }//if        
      // cration de la requte
      $requte="select code from articles";
      // excution de la requte
      $this->execute($requte,TRUE);
      // des erreurs ?
      if(count($this->aErreurs)!=0) return array();
      // on exploite le rsultat
      $aCodes=array();
      $rsultats=$this->oRsultats;
      while ($ligne=$rsultats->fetchRow(DB_FETCHMODE_ASSOC)) {
      	$aCodes[]=$ligne['code'];
  		}//while
      return $aCodes;
    }//getCodes    

    //--------------------------------------------------------------------
    function suivi($dInfos){
    	// affiche un dictionnaire d'informations
      while(list($cl,$valeur)=each($dInfos)){
      	echo "[$cl,$valeur]<br>\n";
      }//while
    }//suivi

  }//classe
?>  	
